#!/usr/bin/perl

use DBI();
use Time::Local; 
use HTTP::Date;
use POSIX qw(strftime);
use File::Basename;
use POSIX qw(ceil floor sqrt);

# Declare the subroutines
# sub trim($);
# sub ltrim($);
# sub rtrim($);
# sub split_code($);
# sub sql_prep($);
# sub txt_prep($);

# MYSQL DB details
$host = "localhost";
$mysql_user = "ngdd_db";
$mysql_passwd = "zaq12wsx";
$database = "ngdd_db";

# Required paths:
$data_folder = "/data/ngdd";
$web_folder = "/var/www/documentation";
$vips = "/usr/local/vips/bin/vips";

$localDB = DBI->connect( "DBI:mysql:database=$database;host=$host",
	$mysql_user, $mysql_passwd, {"RaiseError" => 1} );

sub getSubStrings ($$)
	{
	my $string = shift;
	my $limit = shift;

	$string =~ s/[\/]+/#/g;
	$string =~ s/\s+/#/g;
	$string =~ s/[.]+/#/g;
	$string =~ s/[_]+/#/g;
	$string =~ s/[-]+/#/g;
	$string =~ s/[,]+/#/g;
	$string =~ s/[']+/#/g;
	$string =~ s/[0-9]+/#/g;

	my @output;
	my @subarr = split(/#/, $string);
	my $no = 0;

	foreach $sub (@subarr)
		{
		if (length($sub) >= $limit)
			{$output[$no] = $sub;
			 $no++;}
		}
	
	return @output;
	}

# Perl trim function to remove whitespace from the start and end of the string
sub trim($)
{
	my $string = shift;
	$string =~ s/^\s+//;
	$string =~ s/\s+$//;
	return $string;
}
# Perl trim function to remove whitespace from the start and end of the string
sub dtrim($)
{
	my $string = shift;
	$string =~ s/^[.]+//;
	$string =~ s/[.]+$//;
	$string =~ s/^[-]+//;
	$string =~ s/[-]+$//;
	$string =~ s/^[_]+//;
	$string =~ s/[_]+$//;
	return $string;
}
# Left trim function to remove leading whitespace
sub ltrim($)
{
	my $string = shift;
	$string =~ s/^\s+//;
	return $string;
}
# Right trim function to remove trailing whitespace
sub rtrim($)
{
	my $string = shift;
	$string =~ s/\s+$//;
	return $string;
}

#This function checks for and replaces special charracters which can disrupt SQL queries.
sub sql_prep ($)
	{
	my $val = $_[0];
	
	$val =~ s/^\s+//;
	$val =~ s/\s+$//;
	$val =~ s/\\/\\\\/g;
	$val =~ s/\'/\\\'/g;
	$val =~ s/\`/\\\`/g;

	return ($val);
	}

#This function checks for and replaces special charracters which can disrupt SQL queries.
sub trim_all ($)
	{
	my $val = $_[0];
	
	$val =~ s/\s//g;

	return ($val);
	}

sub split_code($$)
{
	my $match = $_[0];
	my $test = $_[1];

	if ($test)
		{}
	else
		{$test = 4;}

	my $sigfig = $test;
	my $sch = "%0".$sigfig.".0f";
		
	my @code;

	#print "MATCH: $match\n";

	if( $match =~ /^([0-9]+)[.]([0-9]+)/ ) {
    $code[0] = sprintf($sch, $1);
	$code[1] = "= $2";
	$code[2] = sprintf("%03.0f", $2);
	$code[3] = "N";
		}
	elsif( $match =~ /^([0-9]+$)/ ) {
    $code[0] = sprintf($sch, $1);
	$code[1] = "= 0";
	$code[2] = sprintf("%03.0f", 0);
	$code[3] = "N";
		}
	elsif( $match =~ /^([a-zA-Z]+)([0-9]+$)/ ) {
    $code[0] = sprintf($sch, $2);
	$code[1] = "= 0";
	$code[2] = sprintf("%03.0f", 0);
	$code[3] = uc $1;
		}
	elsif( $match =~ /^([a-zA-Z]+)([0-9]+)[.]([0-9]+$)/ ) {
    $code[0] = sprintf($sch, $2);
	$code[1] = "= $3";
	$code[2] = sprintf("%03.0f", $3);
	$code[3] = uc $1;
		}
	elsif( $match =~ /^([a-zA-Z]+)([0-9]+)[.]([0-9]*$)/ ) {
    $code[0] = sprintf($sch, $2);
	$code[1] = "= 0";
	$code[2] = sprintf("%03.0f", 0);
	$code[3] = uc $1;
		}
	elsif( $match =~ /^([0-9]+)[.]$/ ) {
    $code[0] = sprintf($sch, $1);
	$code[1] = "= 0";
	$code[2] = sprintf("%03.0f", 0);
	$code[3] = "N";
		}
	elsif( $match =~ /^([a-zA-Z]+)([0-9]+)[_]([0-9]+)[.]([0-9]+$)/ ) {
    $code[0] = sprintf($sch, $2);
	$code[1] = "= $3";
	$code[2] = sprintf("%03.0f", $3);
	$code[3] = uc $1;
		if ($4)
			{$code[9] = $4 * 1;}
		else
			{$code[9] = 0;}
		}
	elsif( $match =~ /^([a-zA-Z]+)([0-9]+)[_]([0-9]+)[_]([a-zA-Z]+)[.]([0-9]+$)/ ) {
    $code[0] = sprintf($sch, $2);
	$code[1] = "= $3";
	$code[2] = sprintf("%03.0f", $3);
	$code[3] = uc $1;
		}
	elsif( $match =~ /^([a-zA-Z]+)[-]([0-9]+)[-]([0-9]+)[-]([0-9]+)[-]+([a-zA-Z]+)$/ ) {
    $code[0] = sprintf($sch, $2);
	$code[1] = "= $3";
	$code[2] = sprintf("%03.0f", $3);
	$code[3] = uc $1;
		if ($4)
			{$code[9] = $4 * 1;}
		else
			{$code[9] = 0;}
		} #U-0000-00-000467T-pyr.tif N-1864-00-000018-PYR.tif
	elsif( $match =~ /^([a-zA-Z]+)[-]([0-9]+)[-]([0-9]+)[-]([0-9]+)[T]*[-]([a-zA-Z.]*)$/ ) {
    $code[0] = sprintf($sch, $2);
	$code[1] = "= $3";
	$code[2] = sprintf("%03.0f", $3);
	$code[3] = uc $1;
		if ($4)
			{$code[9] = $4 * 1;}
		else
			{$code[9] = 0;}
		}#N-0041-00-000002
	elsif( $match =~ /^([a-zA-Z]+)[-]([0-9]+)[-]([0-9]+)[-]*([0-9]+)*[T]*[-]*([a-zA-Z.]*)$/ ) {
    $code[0] = sprintf($sch, $2);
		$code[1] = "= $3";
		$code[2] = sprintf("%03.0f", $3);
		$code[3] = uc $1;
		if ($4)
			{$code[9] = $4 * 1;}
		else
			{$code[9] = 0;}
		}
	else {
  $code[0] = sprintf($sch, 0);
	$code[1] = "= 0";
	$code[2] = "000";
	$code[3] = "N";
		}
		
	if ( $code[3] eq "NG" )
		{$code[3] = "N";}

	my $at = "";

	if ($code[3] eq "N")
		{$at = "NG";}
	else
		{$at = "$code[3]";}

	my $aan = $code[0] + 0;
	my $aasn = $code[2] +0;

	if ($aasn)
		{
		# Display NG Inventory No.
		$code[5] = "$at$aan".".$aasn";
		$code[6] = "$code[3]"."-$aan"."-$aasn";
		}
	else
		{
		# Display NG Inventory No.
		$code[5] = "$at$aan";
		$code[6] = "$code[3]"."-$aan";
		}
	
	# NG painting related image filename base	
	$code[7] = "$code[3]"."-$code[0]"."-".sprintf("%02.0f", $code[2]);	
	$code[8] = sprintf($sch, $code[0])."-".sprintf("%02.0f", $code[2]);

	# Alpha searchable NG code
	$code[4] = "$code[3]$code[0]"."."."$code[2]";
	if ($code[9])
		{$code[10] = sprintf("%06.0f", $code[9]);}
	else
		{$code[10] = sprintf("%06.0f", 0);}

	return @code;
		
}

#This function checks for and replaces special charracters which can disrupt SQL queries.
sub txt_prep ($)
	{
	my $val = $_[0];
	
	if ($val)
	{
	$val =~ s/^\s+//;
	$val =~ s/\s+$//;
	$val =~ s/\\/\\\\/g;
	$val =~ s/\'/\\\'/g;
	$val =~ s/\`/\\\`/g;
	$val =~ s/\n/<br>/g;
	$val =~ s/\r/<br>/g;
	}
	
	return ($val);
	}

sub getKey{

	($var, @arr) = @_ ;
	my $no = 0;

	foreach (@arr) {
		if ($_ eq $var)
			{return ($no);}
		$no++;
		}

	return (-1);
	}

sub getNextNo ($$$)
	{
	my $path = $_[0];
	my $base = $_[1];
	my $test = $_[2];

	if ($test > 0)
		{}
	else
		{$test = 4;}

	my $sigfig = $test;
	my $sch = "%0".$sigfig.".0f";

	if ($_[2])
		{my $sigfig = $_[2];}
	else
		{my $sigfig = 4;}

	my @output_current = `ls -ltRX \"$path/$base\"*`;
	my $new_no = 1;

	foreach $line (@output_current)
		{
		if ( $line =~ /^[^d].{9}[ ]+[0-9]+[ ]+[a-z-]+[ ]+[a-z-]+[ ]+[0-9]+[ ]+[0-9-]+[ ][0-9:]+[ ](.+)$base\-([0-9]+)([.]*[a-zA-Z]*)/ )
    	{
			$this = $2 + 0;
			if ($this >= $new_no)
				{$new_no = $this + 1;}
			}
		}

	$new_no =	sprintf($sch, $new_no);

	return ($new_no);
	}


sub get_typeFromDir ($$$)
	{
	my $this_type = $_[0];
	my $this_path = $_[1];
	my $this_limit = $_[2];
	my @output = ();
	my $im_no = 0;

	# The image paths need to be absolute paths rather than relative ones.
	if ( $this_path =~ /^([\/].+)/ )
		{$absPath = $1;}
	else
		{
		my $pwd = trim(`pwd`);
		$absPath = "$pwd/$this_path";
		}

	my @output_current = `ls -ltRX \"$absPath\"`;

	#Check location of and details of images listed
	foreach $line (@output_current)
		{
		if ($this_limit)
			{
			if ($im_no >= $this_limit )
				{@output_current = ();}
			}
		
		if ( $line =~ /^([\/].+)[:]/ )
    		{$current_dir = $1;}
		elsif ( $line =~ /^([.]{2}.+)[:]/ )
    		{$current_dir = $1;}
		elsif ( $line =~ /^total.+/ )
    		{}
		elsif ( $line =~ /^\s+/ )
    		{}
		elsif ( $line =~ /^[^d].{9}[ ]+[0-9]+[ ]+[a-z-]+[ ]+[a-z-]+[ ]+([0-9]+)[ ]+([0-9-]+)[ ]([0-9:]+)[ ]([a-zA-Z0-9 \/]+)(.+)/ )
    		{
			$file = trim("$4$5$6");
			$file_path = "$current_dir/$file";
			$type = trim(`file -b \"$file_path\"`);	

			if ( $type =~ /^.+$this_type.+/ )
				{	
				$output[$im_no] = [$current_dir, $file];
				$im_no++;
				}
			else
				{}
			}
		else
			{}
		}

	return (@output);
	}

sub getFileFormatID ($$)
  {
  my $suffix = $_[0];
  my $name = $_[1]; 

  if ($suffix eq ".jpeg" or $suffix eq ".jpg" or $suffix eq ".JPG")
    {$name = "Jpeg";}
  elsif ($suffix eq ".tif" or $suffix eq ".Tif")
    {$name = "Tiff";}
  elsif ($suffix eq ".pdf")
    {$name = "PDF";}
  elsif ($suffix eq ".doc")
    {$name = "Doc";}
  elsif ($suffix eq ".png" or $suffix eq ".PNG")
    {$name = "Png";}
  elsif ($suffix eq ".gif" or $suffix eq ".GIF")
    {$name = "Gif";}
  elsif ($suffix eq ".ppt" or $suffix eq ".PPT")
    {$name = "PPT";}
  else
    {}#$name = "";}

  my $sql = "SELECT type_id FROM type WHERE type_name = '$name'";

  my $thisQuery = $localDB->prepare( $sql );
	$thisQuery->execute();
	my $row = $thisQuery->fetchrow_arrayref();
  $thisQuery->finish();	  

  my $ffID;

  if( $row->[0] ) 
		{$ffID = $row->[0];}
	else
		{$ffID = 89;}

  return ($ffID);
  }
	
sub getCatID ($)
  {
	my $name   = $_[0];

  my $sql = "SELECT type_id FROM type WHERE type_name = '$name'";

  my $thisQuery = $localDB->prepare( $sql );
	$thisQuery->execute();
	my $row = $thisQuery->fetchrow_arrayref();
  $thisQuery->finish();	  
  #$localDB->disconnect();

  my $catID;

  if( $row->[0] ) 
		{$catID = $row->[0];}

  return ($catID);
  }
# Required to avoid "did not return a true value" error.
1
